<template>
  <el-row :gutter="20">
    <DeptTree @node-click="handleDeptNodeClick" v-model:collapsed="isLeftContentCollapsed" />
    <el-col :xs="24" :span="isLeftContentCollapsed ? 24 : 20">
      <ContentWrap style="border: none">
        <!-- 搜索工作栏 -->
        <el-form
          class="-mb-15px"
          :model="queryParams"
          ref="queryFormRef"
          :inline="true"
          label-width="68px"
        >
          <el-form-item :label="t('operationFill.name')" prop="orderName" style="margin-left: 15px">
            <el-input
              v-model="queryParams.orderName"
              :placeholder="t('operationFill.nameHolder')"
              clearable
              @keyup.enter="handleQuery"
              class="!w-240px"
            />
          </el-form-item>
          <el-form-item :label="t('operationFill.status')" prop="orderStatus">
            <el-select
              v-model="queryParams.orderStatus"
              :placeholder="t('operationFill.status')"
              clearable
              class="!w-240px"
            >
              <el-option
                v-for="dict in getStrDictOptions(DICT_TYPE.OPERATION_FILL_ORDER_STATUS)"
                :key="dict.value"
                :label="dict.label"
                :value="dict.value"
              />
            </el-select>
          </el-form-item>
          <el-form-item
            :label="t('operationFill.createTime')"
            prop="createTime"
            label-width="100px"
          >
            <el-date-picker
              v-model="queryParams.createTime"
              value-format="YYYY-MM-DD HH:mm:ss"
              type="daterange"
              :start-placeholder="t('operationFill.start')"
              :end-placeholder="t('operationFill.end')"
              :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
              class="!w-220px"
            />
          </el-form-item>
          <el-form-item>
            <el-button @click="handleQuery"
              ><Icon icon="ep:search" class="mr-5px" />{{ t('operationFill.search') }}</el-button
            >
            <el-button @click="resetQuery"
              ><Icon icon="ep:refresh" class="mr-5px" />{{ t('operationFill.reset') }}</el-button
            >
            <!--          <el-button-->
            <!--            type="primary"-->
            <!--            plain-->
            <!--            @click="openForm('create')"-->
            <!--            v-hasPermi="['rq:iot-inspect-order:create']"-->
            <!--          >-->
            <!--            <Icon icon="ep:plus" class="mr-5px" /> 新增-->
            <!--          </el-button>-->
            <!--          <el-button
            type="success"
            plain
            @click="handleExport"
            :loading="exportLoading"
            v-hasPermi="['rq:iot-inspect-order:export']"
          >
            <Icon icon="ep:download" class="mr-5px" /> 导出
          </el-button>-->
          </el-form-item>
        </el-form>
      </ContentWrap>

      <!-- 列表 -->
      <ContentWrap style="border: none">
        <zm-table :loading="loading" :data="list" height="calc(85vh - 175px)">
          <zm-table-column :label="t('common.index')" min-width="60" align="center">
            <template #default="scope">
              {{ scope.$index + 1 }}
            </template>
          </zm-table-column>
          <zm-table-column :label="t('bomList.name')" align="center" prop="orderName" />
          <zm-table-column :label="t('operationFill.duty')" align="center" prop="userName" />
          <zm-table-column :label="t('operationFill.orderDevice')" align="center" prop="fillList" />

          <zm-table-column :label="t('operationFill.status')" align="center" prop="orderStatus">
            <template #default="scope">
              <el-tooltip
                v-if="scope.row.orderStatus === 3"
                effect="dark"
                :content="scope.row.reason"
                placement="top"
              >
                <dict-tag
                  :type="DICT_TYPE.OPERATION_FILL_ORDER_STATUS"
                  :value="scope.row.orderStatus"
                />
              </el-tooltip>
              <dict-tag
                v-else
                :type="DICT_TYPE.OPERATION_FILL_ORDER_STATUS"
                :value="scope.row.orderStatus"
              />
            </template>
          </zm-table-column>
          <zm-table-column :label="t('operationFill.deviceCount')" align="center" prop="allDev">
            <template #default="scope">
              <el-tag type="info"> {{ scope.row.allDev }}</el-tag>
            </template>
          </zm-table-column>
          <zm-table-column :label="t('operationFill.fillCount')" align="center" prop="fillDev">
            <template #default="scope">
              <el-tag type="success"> {{ scope.row.fillDev }}</el-tag>
            </template>
          </zm-table-column>
          <zm-table-column :label="t('operationFill.unFillCount')" align="center" prop="unFillDev">
            <template #default="scope">
              <el-tag type="danger"> {{ scope.row.unFillDev }}</el-tag>
            </template>
          </zm-table-column>
          <zm-table-column
            :label="t('dict.createTime')"
            align="center"
            prop="createTime"
            :formatter="dateFormatter"
            min-width="170"
          />
          <zm-table-column
            :label="t('dict.fillTime')"
            align="center"
            prop="updateTime"
            :formatter="dateFormatter"
            min-width="170"
          />
          <zm-table-column
            :label="t('operationFill.operation')"
            align="center"
            min-width="120px"
            fixed="right"
            action
          >
            <template #default="scope">
              <div v-if="scope.row.orderStatus == 0 || scope.row.orderStatus == 2">
                <el-button
                  link
                  type="primary"
                  @click="
                    openWrite(
                      scope.row.deptId +
                        ',' +
                        scope.row.userId +
                        ',' +
                        scope.row.createTime +
                        ',' +
                        scope.row.id +
                        ',' +
                        scope.row.orderStatus
                    )
                  "
                  v-hasPermi="['rq:iot-opeation-fill:update']"
                  v-if="scope.row.orderStatus !== 1"
                >
                  {{ t('operationFill.fill') }}
                </el-button>
                <el-button
                  link
                  type="warning"
                  v-hasPermi="['rq:iot-opeation-fill:update']"
                  v-if="scope.row.orderStatus !== 1"
                  @click="openDialog(scope.row.id)"
                >
                  {{ t('operationFill.ignore') }}
                </el-button>
              </div>
              <div v-else-if="scope.row.orderStatus === 3">
                <el-button
                  link
                  type="success"
                  @click="
                    openWrite(
                      scope.row.deptId +
                        ',' +
                        scope.row.userId +
                        ',' +
                        scope.row.createTime +
                        ',' +
                        scope.row.id +
                        ',' +
                        scope.row.orderStatus
                    )
                  "
                >
                  {{ t('operationFill.view') }}
                </el-button>
              </div>
              <div v-else>
                <el-button
                  link
                  type="primary"
                  @click="
                    openWrite(
                      scope.row.deptId +
                        ',' +
                        scope.row.userId +
                        ',' +
                        scope.row.createTime +
                        ',' +
                        scope.row.id +
                        ',' +
                        0
                    )
                  "
                  v-hasPermi="['rq:iot-opeation-fill:update']"
                  v-if="isSameDay(scope.row.createTime)"
                >
                  {{ t('fault.edit') }}
                </el-button>
                <el-button
                  link
                  type="success"
                  @click="
                    openWrite(
                      scope.row.deptId +
                        ',' +
                        scope.row.userId +
                        ',' +
                        scope.row.createTime +
                        ',' +
                        scope.row.id +
                        ',' +
                        scope.row.orderStatus
                    )
                  "
                >
                  {{ t('operationFill.view') }}
                </el-button>
              </div>

              <!-- 编辑按钮 -->
            </template>
          </zm-table-column>
        </zm-table>
        <el-dialog
          v-model="dialogVisible"
          title="忽略理由"
          :width="600"
          :before-close="handleClose"
          append-to-body
          :close-on-click-modal="false"
        >
          <el-form ref="reasonFormRef" :model="form" :rules="rules" label-width="60px">
            <el-form-item label="理由" prop="reason">
              <el-input
                type="textarea"
                v-model="form.reason"
                placeholder="请输入忽略理由"
                :rows="4"
                resize="none"
              />
            </el-form-item>
          </el-form>

          <template #footer>
            <el-button @click="handleCancel">取消</el-button>
            <el-button type="primary" @click="handleConfirm">确定</el-button>
          </template>
        </el-dialog>
        <!-- 分页 -->
        <Pagination
          :total="total"
          v-model:page="queryParams.pageNo"
          v-model:limit="queryParams.pageSize"
          @pagination="getList"
        />
      </ContentWrap>
    </el-col>
  </el-row>
  <!-- 表单弹窗：添加/修改 -->
  <IotInspectOrderForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import { IotInspectOrderApi, IotInspectOrderVO } from '@/api/pms/inspect/order'
//import IotInspectOrderForm from './IotInspectOrderForm.vue'
import { DICT_TYPE, getStrDictOptions } from '@/utils/dict'
import DeptTree from '@/views/system/user/DeptTree2.vue'
import { onMounted, ref } from 'vue'
import { IotOpeationFillApi, IotOpeationFillVO } from '@/api/pms/iotopeationfill'
import { useUserStore } from '@/store/modules/user'

import { useTableComponents } from '@/components/ZmTable/useTableComponents'
const { ZmTable, ZmTableColumn } = useTableComponents()
const { push } = useRouter()
const { query } = useRoute() // 查询参数
const deptId = query.deptId
const orderStatus = query.orderStatus
const createTime = query.createTime

/** 巡检工单 列表 */
defineOptions({ name: 'IotOpeationFill1' })
const dialogVisible = ref(false)
const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化
let isLeftContentCollapsed = ref(false)
const loading = ref(true) // 列表的加载中
const list = ref<IotOpeationFillVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  inspectOrderTitle: undefined,
  inspectOrderCode: undefined,
  status: undefined,
  remark: undefined,
  createTime: [],
  deptId: useUserStore().getUser.deptId,
  deviceIds: undefined,
  orderStatus: undefined
  //userId:useUserStore().getUser.id
})

const form = reactive({
  id: undefined,
  reason: ''
})

// 表单验证规则
const rules = {
  reason: [
    { required: true, message: '请输入忽略理由', trigger: 'blur' },
    { min: 2, message: '理由长度不能少于2个字符', trigger: 'blur' }
  ]
}
// 打开对话框
const openDialog = (id: number) => {
  dialogVisible.value = true
  form.id = id
  form.reason = ''
}

const truncateText = (text: string, maxLength: number) => {
  if (!text) return ''
  return text.length > maxLength ? text.substring(0, maxLength) + '...' : text
}
// 取消按钮处理
const handleCancel = () => {
  dialogVisible.value = false
  resetForm()
}

// 确定按钮处理
const handleConfirm = async () => {
  // 表单验证
  try {
    await reasonFormRef.value.validate()
    // 验证通过，调用接口
    await IotOpeationFillApi.updateIotOpeationFill1(form)
    ElMessage.success('操作成功')
    dialogVisible.value = false
    resetForm()
  } catch (error) {
    return
  }
}
// 重置表单
const resetForm = () => {
  reasonFormRef.value?.resetFields()
}
const reasonFormRef = ref(null)

const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

// 新增变量用于控制悬浮提示
const hoverRowId = ref<number | null>(null)

// 鼠标进入表格单元格时
const handleMouseEnter = (row: IotOpeationFillVO) => {
  hoverRowId.value = row.id
}

// 鼠标离开表格单元格时
const handleMouseLeave = () => {
  hoverRowId.value = null
}

// 定义要显示的悬浮内容
const getTooltipContent = (row: IotOpeationFillVO) => {
  // 根据实际需求自定义显示内容
  return `
    ${t('operationFill.name')}: ${row.orderName || '-'}\n
    ${t('operationFill.duty')}: ${row.userName || '-'}\n
    ${t('dict.createTime')}: ${row.createTime ? dateFormatter(row.createTime) : '-'}
  `
}

// 判断两个日期是否为同一天
const isSameDay = (dateString) => {
  if (!dateString) return false

  // 将日期字符串转换为日期对象
  const targetDate = new Date(dateString)
  const today = new Date()

  // 比较年、月、日
  return (
    targetDate.getFullYear() === today.getFullYear() &&
    targetDate.getMonth() === today.getMonth() &&
    targetDate.getDate() === today.getDate()
  )
}

const handleDeptNodeClick = async (row) => {
  queryParams.deptId = row.id
  await getList()
}
/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await IotOpeationFillApi.getIotOpeationFillPage1(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (id?: number) => {
  push({ name: 'InspectOrderDetail', params: { id } })
}

const openWrite = (id?: string) => {
  push({ name: 'FillOrderInfo', params: { id } })
}
/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await IotInspectOrderApi.deleteIotInspectOrder(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await IotInspectOrderApi.exportIotInspectOrder(queryParams)
    download.excel(data, '巡检工单.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(async () => {
  // 计算近一周时间
  const end = new Date()
  const start = new Date()
  start.setTime(start.getTime() - 7 * 24 * 60 * 60 * 1000)

  // 格式化日期为后端需要的格式
  const formatDate = (date) => {
    const year = date.getFullYear()
    const month = String(date.getMonth() + 1).padStart(2, '0')
    const day = String(date.getDate()).padStart(2, '0')
    const hours = String(date.getHours()).padStart(2, '0')
    const minutes = String(date.getMinutes()).padStart(2, '0')
    const seconds = String(date.getSeconds()).padStart(2, '0')
    return `${year}-${month}-${day} ${hours}:${minutes}:${seconds}`
  }

  queryParams.createTime = [formatDate(start), formatDate(end)]

  if (deptId != null) {
    queryParams.deptId = deptId
  }
  if (orderStatus === 4) {
    queryParams.orderStatus = null
  }
  if (orderStatus != null && orderStatus != 4) {
    queryParams.orderStatus = orderStatus
  }
  if (createTime) {
    const timeArr = createTime.split(',')
    if (timeArr.length === 2) {
      queryParams.createTime = timeArr
    } else {
      // 处理格式不正确的情况，可以给个默认值或提示
      console.warn('createTime参数格式不正确')
    }
    //queryParams.createTime = createTime;
  }

  getList()
})
</script>

<style lang="scss">
.scrollable-tooltip {
  min-height: 100px;
  overflow-y: auto;
  overflow-x: hidden;
  /* white-space: pre-wrap;
  word-break: break-word; */
  background-color: rgba(0, 0, 0, 0.8);
  color: #fff;
  font-size: 14px;
}
.project-popover.el-popover.el-popper {
  opacity: 0.8;
  background: #000000;
  border: none !important;
  font-size: 14px;
  color: #ffffff;
  font-weight: 400;
  min-width: 54px;

  .el-popper__arrow::before {
    background: #000000;
    border: none;
  }
}
</style>

<style scoped lang="scss"></style>
